/**
 * metadata/SlotMetadata.java
 *
 * File generated from the SlotMetadata uml Class
 * Generated by the Acceleo UML 2.1 to Java generator module (Obeo)
 */
package net.ihe.gazelle.metadata.model;

// End of user code
import java.io.Serializable;
import java.util.List;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.jboss.seam.annotations.Name;


/**
 * Description of the class SlotMetadata.
 *
 */
@Entity
@Name("slotMetadata")
@Table(name="slot_metadata", schema = "public")
@SequenceGenerator(name = "slot_metadata_sequence", sequenceName = "slot_metadata_id_seq", allocationSize=1)

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "SlotMetadata")
@XmlRootElement(name = "SlotMetadata")

public class SlotMetadata implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=GenerationType.SEQUENCE, generator="slot_metadata_sequence")
	@XmlTransient
	private Integer id;
	
	private String name;
		
	private Boolean multiple;
	
	private Boolean supportAndOr;
	
	private String defaultValue;
	
	private String attribute;
	
	@Size(max=500)
	private String valueset;
	
	private Boolean isNumber;
	
	private Boolean isCodeOnly;
	
	private String regex;
	
	// Start of user code to add fields for SlotMetadata
	 
	// End of user code
	
	public boolean getIsCodeOnlyAsBoolean() {
		if (isCodeOnly != null) {
			return isCodeOnly;
		}
		return false;
	}
	
	public Boolean getIsCodeOnly() {
		return isCodeOnly;
	}

	public void setIsCodeOnly(Boolean isCodeOnly) {
		this.isCodeOnly = isCodeOnly;
	}

	public Boolean getIsNumber() {
		return isNumber;
	}

	public void setIsNumber(Boolean isNumber) {
		this.isNumber = isNumber;
	}

	/**
	 * Return id.
	 * @return id
	 */
	public Integer getId() {
	    return id;
	}
	
	/**
	 * Set a value to attribute id.
	 * @param id.
	 */
	public void setId(Integer id) {
	    this.id = id;
	}
	
	
	
	/**
	 * Return name.
	 * @return name
	 */
	public String getName() {
	    return name;
	}
	
	/**
	 * Set a value to attribute name.
	 * @param name.
	 */
	public void setName(String name) {
	    this.name = name;
	}
	
	/**
	 * Return multiple.
	 * @return multiple
	 */
	public Boolean getMultiple() {
	    return multiple;
	}
	
	/**
	 * Set a value to attribute multiple.
	 * @param multiple.
	 */
	public void setSupportAndOr(Boolean supportAndOr) {
	    this.supportAndOr = supportAndOr;
	}
	
	public Boolean getSupportAndOr() {
	    return supportAndOr;
	}
	
	/**
	 * Set a value to attribute multiple.
	 * @param multiple.
	 */
	public void setMultiple(Boolean multiple) {
	    this.multiple = multiple;
	}
	
	/**
	 * Return defaultValue.
	 * @return defaultValue
	 */
	public String getDefaultValue() {
	    return defaultValue;
	}
	
	/**
	 * Set a value to attribute defaultValue.
	 * @param defaultValue.
	 */
	public void setDefaultValue(String defaultValue) {
	    this.defaultValue = defaultValue;
	}
	
	
	
	/**
	 * Return attribute.
	 * @return attribute
	 */
	public String getAttribute() {
	    return attribute;
	}
	
	/**
	 * Set a value to attribute attribute.
	 * @param attribute.
	 */
	public void setAttribute(String attribute) {
	    this.attribute = attribute;
	}
	
	
	
	/**
	 * Return valueset.
	 * @return valueset
	 */
	public String getValueset() {
	    return valueset;
	}
	
	/**
	 * Set a value to attribute valueset.
	 * @param valueset.
	 */
	public void setValueset(String valueset) {
	    this.valueset = valueset;
	}
	
	public String getRegex() {
		return regex;
	}

	public void setRegex(String regex) {
		this.regex = regex;
	}
	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(SlotMetadata slotMetadata, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (slotMetadata != null){
   			cvm.validate(slotMetadata, location, diagnostic);
    	}
    }

}